/* 
 * common.c Υإåե
 * common.h
 * shige
 * 12/27 2003
 * 
 * $Id: common.h,v 1.12 2004-01-07 18:35:18+09 shige Exp $
 */
#ifndef __COMMON_H__
#define __COMMON_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sndio.h"
#include "wavio.h"
#include "aiffio.h"

#include "cstruct.h"
#include "error.h"

typedef union {
    Snddata au;
    WAVdata wav;
    AIFFdata aiff;
} SNDheader;

enum {E_AU=0,E_WAV,E_AIFF,E_UNKNOWN}; 

/* for SNDchheaderMASK() */
#define CH_MAGIC 0x0001
#define CH_FMCODE 0x0002
#define CH_CHANNEL 0x0004
#define CH_SMPLRATE 0x0008
#define CH_BLOCKSIZE 0x0010
#define CH_BITPERSMPL 0x0020
#define CH_BYTEPERSEC 0x0040
#define CH_ALL (CH_MAGIC|CH_FMCODE|CH_CHANNEL|CH_SMPLRATE|CH_BLOCKSIZE\
		|CH_BITPERSMPL|CH_BYTEPERSEC)

#ifdef __COMMON_C__
/* for SNDgetmaxlevel() */
# ifndef Max
#  define Max(a,b)  (((a)>(b))?(a):(b))
# endif
# ifndef Abs
#  define Abs(a)  Max((a),-(a))
# endif
#endif

#ifdef __COMMON_C__
# define EXTERN_COMMON 
#else
# define EXTERN_COMMON extern 
#endif

EXTERN_COMMON int getSNDheader(FILE *file,SNDheader *snd);
EXTERN_COMMON int put1SNDheader(FILE *file,SNDheader *snd,int format);
EXTERN_COMMON int putallSNDheader(FILE *file,SNDheader *snd,int N,int format);
EXTERN_COMMON int putallSNDheaderOpt(FILE *file,SNDheader *snd,int N,
				     ConnOpt *opt,int format);
EXTERN_COMMON int putSNDheaderBlocks(FILE *file,SNDheader *snd,int blocks,
				     int format);
EXTERN_COMMON int putSNDheaderBlocksChannels(FILE *file,SNDheader *snd,
					     int blocks,int channels,int format);
EXTERN_COMMON int putSNDheaderBlocksSmplrate(FILE *file,SNDheader *snd,
					     int blocks,double smplrate,
					     int format);
EXTERN_COMMON int cpSNDheader(SNDheader *new,SNDheader *org,int format);
EXTERN_COMMON void SNDputtrans(FILE *infile,FILE *outfile,SNDheader *snd,
			       int format,int olen,double times);
EXTERN_COMMON void SNDskip1chdata(FILE *infile,SNDheader *snd,int format);
EXTERN_COMMON void SNDreadput1chdata(FILE *infile,FILE *outfile,SNDheader *snd,
				     int format);
EXTERN_COMMON void SNDreadput1chdatavol(FILE *infile,FILE *outfile,
					SNDheader *snd,int format,double vol);
EXTERN_COMMON void SNDputnull1ch(FILE *outfile,SNDheader *snd,int format);
EXTERN_COMMON int SNDput1chleveldata(FILE *outfile,double data,SNDheader *snd,
				     int format);
EXTERN_COMMON double SNDget1chleveldata(FILE *infile,SNDheader *snd,int format);
EXTERN_COMMON int SNDblocksize(SNDheader *snd,int format);
EXTERN_COMMON int SNDbitpersmpl(SNDheader *snd,int format);
EXTERN_COMMON int SNDchannels(SNDheader *snd,int format);
EXTERN_COMMON int SNDchheaderMASK(SNDheader *snd1,SNDheader *snd2,int format,
				  int mask);
EXTERN_COMMON long int SNDblocks(SNDheader *snd,int format);
EXTERN_COMMON long int SNDdatalen(SNDheader *snd,int format);
EXTERN_COMMON long int SNDhlen(SNDheader *snd,int format);
EXTERN_COMMON double SNDsmplrate(SNDheader *snd,int format);
EXTERN_COMMON double SNDgetmaxlevel(FILE *infile,SNDheader *snd,int format);
EXTERN_COMMON double SNDgetmaxlevelChannel(FILE *infile,SNDheader *snd,
					   int format,double maxlevel[]);
#endif /* __COMMON_H__ */
