/* file ϴܴؿ
 * shige
 * 11/03 2000
 * fileio.c
 *
 * $Id: fileio.c,v 1.1 2000-11-03 18:43:45+09 shige Exp $
 */
#ifndef __FILEIO_C__
#define __FILEIO_C__

#include "fileio.h"

/* file1 Υǡʬ file2 ˽񤭽Ф */
void putfile2file(FILE *file1,FILE *file2,long int pos,long int len)
{
    long int j;

    fseek(file1,pos,SEEK_SET);
    for(j=1;j<=len;j++) fputc(fgetc(file1),file2);
}

/* ########## 2byte, 4byte  data ɤ߹ ########## */
/* ##### BIG ENDIAN ##### */
int read4bytetoi(FILE *file,long int *J)
{
    static unsigned char s[4]={0,0,0,0};
    
    if(fread(s,4,1,file)<1) return Err_fread;
    *J=sto4bytei(s);
    return No_err;
}

int read2bytetoi(FILE *file,short int *J)
{
    static unsigned char s[2]={0,0};
    
    if(fread(s,2,1,file)<1) return Err_fread;
    *J=sto2bytei(s);
    return No_err;
}

void writeito4byte(FILE *file,unsigned long int n)
{
    fputc((n>>24)&0x00ff,file);
    fputc((n>>16)&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
    fputc(n&0x00ff,file);
}

void writeito2byte(FILE *file,unsigned short int n)
{
    fputc((n>>8)&0x00ff,file);
    fputc(n&0x00ff,file);
}

/* ##### LITTLE ENDIAN ##### */
int read4bytetolittlei(FILE *file,long int *J)
{
    static unsigned char s[4]={0,0,0,0};
    
    if(fread(s,4,1,file)<1) return Err_fread;
    *J=sto4bytelittlei(s);
    return No_err;
}

int read2bytetolittlei(FILE *file,short int *J)
{
    static unsigned char s[2]={0,0};
    
    if(fread(s,2,1,file)<1) return Err_fread;
    *J=sto2bytelittlei(s);
    return No_err;
}

void writelittleito4byte(FILE *file,unsigned long int n)
{
    fputc(n&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
    fputc((n>>16)&0x00ff,file);
    fputc((n>>24)&0x00ff,file);
}

void writelittleito2byte(FILE *file,unsigned short int n)
{
    fputc(n&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
}

#endif /* __FILEIO_C__ */
