/*
 * ʣͥβ file  mix 
 * shige
 * 08/29 2005
 * 
 * $Id: sndchmix.c,v 1.1 2005-08-30 20:55:28+09 shige Exp $
 *
 * sndchmix (-o[file]) (-d1|d2) ([channel specs]) ([infile])
 *  [channel specs] = [channel spec] (:[channel spec])*
 *   [channel spec] = [n](+[n])*
 * Ex.
 *   1+2+3:4:5+6
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define Maxbuff 8192
#define Maxchan 50
#define OpSep ":"

int main(int argc,char *argv[]);
int mysplit(char *h[],char *s,char *Delimit,int maxsize);
int str2charray(char *s,int *M,int *Charray[],int N[]);
int str2ia(char *s0,int **Array,int *N);
int getarg(int argc,char **argv,char **Chstr,int *Div,
	   FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    int *charray[Maxchan],N[Maxchan],M,format,blocks,bs,bps;
    int j,k,n,m,ret,chnum,dmode;
    char *chs;
    double chdata[Maxchan],x;
    
    if((ret=getarg(argc,argv,&chs,&dmode,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((ret=str2charray(chs,&M,charray,N))<0){
	usage(ret-10); return -ret;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",ret);
	return 20;
    }
    if((chnum=SNDchannels(&snd,format))>Maxchan){
	fprintf(stderr,"Error: too many channels in data. (%d)\n",chnum);
	return 30;
    }
    blocks=SNDblocks(&snd,format);
    bps=SNDbitpersmpl(&snd,format);
#ifdef DEBUG1
    fprintf(stderr,"input: channel=%d\n",chnum);
    fprintf(stderr,"output: channel=%d\n",M);
    for(k=1;k<=M;k++){
	fprintf(stderr," ch %d:",k);
	for(n=1;n<=N[k-1];n++) fprintf(stderr,"[%d]",charray[k-1][n-1]);
	fprintf(stderr,"\n");
    }
    fprintf(stderr,"dmode=%d\n",dmode);
#endif
    putSNDheaderBlocksChannels(outfile,&snd,blocks,M,format);
    for(j=1;j<=blocks;j++){
	for(k=1;k<=chnum;k++) 
	  chdata[k-1]=SNDget1chleveldata(infile,&snd,format);
#ifdef DEBUG2
	if(j==100){
	    for(k=1;k<=chnum;k++)
	      fprintf(stderr,"DEBUG2:chdata[%d-1]=%f\n",k,chdata[k-1]);
	}
#endif
	for(k=1;k<=M;k++){
	    x=0.0;
	    for(n=1;n<=N[k-1];n++){
		if((m=charray[k-1][n-1])<0 && -m<=chnum) x-=chdata[-m-1];
		else if(m>0 && m<=chnum) x+=chdata[m-1];
	    }
	    if(dmode==1) x/=N[k-1];
#ifdef DEBUG2
	    if(j==100){
		fprintf(stderr,"DEBUG2: out[%d-1]=%f\n",k,x);
	    }
#endif
	    SNDput1chleveldata(outfile,x,&snd,format);
	}
    }
    bs=SNDblocksize(&snd,format)/M;
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    /* ää ? */
    return 0;
}

/* strtok()  A:::B  1=A, 2=B ˤʤäƤޤΤǡ
 * 1=A, 2="", 3="", 4=B Ȥ
 */ 
int mysplit(char *h[],char *s,char *Delimit,int maxsize)
{
    char *s1,*s2;
    int j=0;
    
    s1=s;
    while((s2=strpbrk(s1,Delimit))!=NULL){
	if(++j>maxsize) return -1;
	*s2='\0';
	h[j-1]=s1;
	s1=s2+1;
    }
    if(++j>maxsize) return -1;
    h[j-1]=s1;
    return j;
}

int str2charray(char *s,int *M,int *Charray[],int N[])
{
    char *sp[Maxchan];
    int j,ret;

    if((*M=mysplit(sp,s,OpSep,Maxchan))<0) return -1;
    for(j=1;j<=*M;j++)
      if((ret=str2ia(sp[j-1],&(Charray[j-1]),&(N[j-1])))<0) return ret-10;
    return 0;
}

int str2ia(char *s0,int **Array,int *N)
{
    int len;
    char *s1,*s2,c;
    int buff[Maxbuff],sign,j;

    if(s0==NULL || (len=strlen(s0))<0) return -1;
    *N=0; *Array=NULL;
    if(len==0) return 0;
    if(isdigit(*s0) || *s0=='+') sign=1;
    else if(*s0=='-') sign=-1;
    else return -2;
    if(isdigit(*s0)) s1=s2=s0;
    else s1=s2=s0+1; 
    if(!isdigit(*s1) || *s1=='0') return -3;
    s2++;
    while(1){
	if(*s2=='+' || *s2=='-' || *s2=='\0'){
	    if(++(*N)>Maxbuff) return -4;
	    c=*s2; *s2='\0';
	    if((buff[*N-1]=atoi(s1))==0) return -5;
	    if(sign==-1) buff[*N-1]*=-1;
	    if(c=='\0'){ /* λ */
		if((*Array=(int *)malloc(sizeof(int)*(*N)))==NULL) return -6;
		for(j=1;j<=*N;j++) (*Array)[j-1]=buff[j-1];
		return 1;
	    }
	    else if(c=='+') sign=1;
	    else sign=-1;
	    s2++; s1=s2;
	    if(!isdigit(*s1) || *s1=='0') return -3;
	}
	else if(!isdigit(*s2)) return -6;
	s2++;
    }
}

int getarg(int argc,char **argv,char **Chstr,int *Div,
	   FILE **infile,FILE **outfile)
{
    *outfile=stdout;
    *infile=stdin;
    *Chstr=NULL;
    *Div=1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'd': 
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -1;
		    else argv++;
		}
		if((*Div=atoi(*argv))!=1 && *Div!=2) return -2;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -4;
		    else argv++;
		}
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc<1) return 1;
    *Chstr=*argv;
    if(argc==1 || !strcmp(*(++argv),"-")) *infile=stdin;
    else if((*infile=fopen(*argv,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndchmix (-o [outfile]) (-d[n]) [channel ] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   -d[n]: ŤߤΤĤ (-d1: ʿ, -d2: ñ)",
	"   [infile]: ϥե (ά: ɸ)",
	"   [channel : Ф channel ",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] channel ϡchannel ֹ +, - (ȿž) ǻꤹ롣",
	"   ʣ channel νϤԤȤ ':' ǶڤäƵҤ롣",
	"   ꤬ʤ channel ̵ˤʤ롣:",
	"     1+2-4   ==> 1,2,4ch  mix (4ch ϰȿž)",
	"     1+2:1-2 ==> Ϥ 1,2ch  mix  1ch ȤơϤ 1,2ch",
	"                 (2ch ϰȿž)  mix  2ch Ȥƽ",
	"     1::3:   ==> 1ch,3ch 򤽤Τޤ޽Ϥ2ch,4ch ̵ˤ",
	" [3] -d ϡ㤨 1+2+3+4  channel ξ硢-d1 ξ",
	"   1,2,3,4 ȷ¤ 4 ǳäͤϤȤ뤬-d2 ξ",
	"   1,2,3,4 ȷ¤ΤΤϤȤ롣ä -d2 ξϥ",
	"   󥸤ۤǽꡢ-d1 ξϲʤǽ",
	"   롣-d1 Ȥäơ礭 sndvol/sndlevel ʤɤĴ᤹",
	"   ˾ޤ",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
